$(document).ready(function(){
	Queries = []
	$('.fetch_data_async').each(function(i, elem){
		var model_name = $(elem).data().model_name;
		var model_id = $(elem).data().model_id;
		var model_method = $(elem).data().model_method;
		var display_error = $(elem).data().display_error;

		var func_done = function(data){
			//console.log("SUCCEED: " + data.success)
			$(elem).text(data.success);
		};
		var func_error = function(data){
			if(display_error) {
				if (typeof data.responseJSON !== "undefined"){
					console.log("ERROR: " + data.responseJSON.error);
					$(elem).text("ERROR: " + data.responseJSON.error);
				}
			} else {
				$(elem).text("FAILED");
				console.log("You can use 'display_error: true' to get more detailed on the error.")
			}
		};
		var func_always = function(data){
			delete Queries[i];
			console.log("Delete query #" + i + ", left: " + Queries);
		};

		query = $.ajax({
			url: '/async_data_fetch/get_async_data',
			data: 'model_name=' + model_name + "&model_id=" + model_id + "&model_method=" + model_method,
			method: 'post',
			async: true,
			success: func_done,
			done: func_done,
			error: func_error,
			fail: func_error,
			complete: func_always,
			always: func_always
		});

		Queries[i] = query;
	});

	var kill_ajax = function() {
		$.each(Queries, function(i, query){
			if (typeof query === "undefined"){
				return;
			}
			console.log("Abort: #" + i + ": " + JSON.stringify(query));
			result = query.abort();
			console.log("Abort: #" + i + ": " + JSON.stringify(result));
		});
	};

	$(window).bind('beforeunload', kill_ajax);
	$(window).on('unload', kill_ajax);
});
//= javascript_include_tag '//ajax.googleapis.com/ajax/libs/jquery/1.6.2/jquery.min.js', :defer => true, :async => true

;
// Place all the behaviors and hooks related to the matching controller here.
// All this logic will automatically be available in application.js.
;
// Place all the behaviors and hooks related to the matching controller here.
// All this logic will automatically be available in application.js.
;
// This is a manifest file that'll be compiled into application.js, which will include all the files
// listed below.
//
// Any JavaScript/Coffee file within this directory, lib/assets/javascripts, vendor/assets/javascripts,
// or any plugin's vendor/assets/javascripts directory can be referenced here using a relative path.
//
// It's not advisable to add code directly here, but if you do, it'll appear at the bottom of the
// compiled file.
//
// Read Sprockets README (https://github.com/rails/sprockets#sprockets-directives) for details
// about supported directives.
//


